Index: /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLab.Algorithms.GeneticAlgorithm-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLab.Algorithms.GeneticAlgorithm-3.3.csproj	(revision 3355)
+++ /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLab.Algorithms.GeneticAlgorithm-3.3.csproj	(revision 3356)
@@ -85,4 +85,6 @@
     <Compile Include="GeneticAlgorithmMainLoop.cs" />
     <Compile Include="HeuristicLabAlgorithmsGeneticAlgorithmPlugin.cs" />
+    <Compile Include="IslandGeneticAlgorithm.cs" />
+    <Compile Include="IslandGeneticAlgorithmMainLoop.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 3356)
+++ /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 3356)
@@ -0,0 +1,478 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Selection;
+
+namespace HeuristicLab.Algorithms.GeneticAlgorithm {
+  /// <summary>
+  /// An island genetic algorithm.
+  /// </summary>
+  [Item("Island Genetic Algorithm", "An island genetic algorithm.")]
+  [Creatable("Algorithms")]
+  [StorableClass]
+  public sealed class IslandGeneticAlgorithm : EngineAlgorithm {
+    #region Fields
+    [Storable]
+    private IslandGeneticAlgorithmMainLoop mainLoop;
+    [Storable]
+    private SolutionsCreator solutionsCreator;
+    [Storable]
+    private RandomCreator randomCreator;
+    #endregion
+
+    #region Problem Properties
+    public override Type ProblemType {
+      get { return typeof(ISingleObjectiveProblem); }
+    }
+    public new ISingleObjectiveProblem Problem {
+      get { return (ISingleObjectiveProblem)base.Problem; }
+      set { base.Problem = value; }
+    }
+    #endregion
+
+    #region Parameter Properties
+    private ValueParameter<IntValue> SeedParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Seed"]; }
+    }
+    private ValueParameter<BoolValue> SetSeedRandomlyParameter {
+      get { return (ValueParameter<BoolValue>)Parameters["SetSeedRandomly"]; }
+    }
+    private ValueParameter<IntValue> NumberOfIslandsParameter {
+      get { return (ValueParameter<IntValue>)Parameters["NumberOfIslands"]; }
+    }
+    private ValueParameter<IntValue> MigrationIntervalParameter {
+      get { return (ValueParameter<IntValue>)Parameters["MigrationInterval"]; }
+    }
+    private ValueParameter<PercentValue> MigrationRateParameter {
+      get { return (ValueParameter<PercentValue>)Parameters["MigrationRate"]; }
+    }
+    private ConstrainedValueParameter<IMigrator> MigratorParameter {
+      get { return (ConstrainedValueParameter<IMigrator>)Parameters["Migrator"]; }
+    }
+    private ConstrainedValueParameter<ISelector> EmigrantsSelectorParameter {
+      get { return (ConstrainedValueParameter<ISelector>)Parameters["EmigrantsSelector"]; }
+    }
+    private ConstrainedValueParameter<ISelector> ImmigrationSelectorParameter {
+      get { return (ConstrainedValueParameter<ISelector>)Parameters["ImmigrationSelector"]; }
+    }
+    private ValueParameter<IntValue> PopulationSizeParameter {
+      get { return (ValueParameter<IntValue>)Parameters["PopulationSize"]; }
+    }
+    private ValueParameter<IntValue> MaximumMigrationsParameter {
+      get { return (ValueParameter<IntValue>)Parameters["MaximumMigrations"]; }
+    }
+    private ConstrainedValueParameter<ISelector> SelectorParameter {
+      get { return (ConstrainedValueParameter<ISelector>)Parameters["Selector"]; }
+    }
+    private ConstrainedValueParameter<ICrossover> CrossoverParameter {
+      get { return (ConstrainedValueParameter<ICrossover>)Parameters["Crossover"]; }
+    }
+    private ValueParameter<PercentValue> MutationProbabilityParameter {
+      get { return (ValueParameter<PercentValue>)Parameters["MutationProbability"]; }
+    }
+    private OptionalConstrainedValueParameter<IManipulator> MutatorParameter {
+      get { return (OptionalConstrainedValueParameter<IManipulator>)Parameters["Mutator"]; }
+    }
+    private ValueParameter<IntValue> ElitesParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Elites"]; }
+    }
+    private ValueParameter<BoolValue> ParallelParameter {
+      get { return (ValueParameter<BoolValue>)Parameters["Parallel"]; }
+    }
+    #endregion
+
+    #region Properties
+    public IntValue Seed {
+      get { return SeedParameter.Value; }
+      set { SeedParameter.Value = value; }
+    }
+    public BoolValue SetSeedRandomly {
+      get { return SetSeedRandomlyParameter.Value; }
+      set { SetSeedRandomlyParameter.Value = value; }
+    }
+    public IntValue NumberOfIslands {
+      get { return NumberOfIslandsParameter.Value; }
+      set { NumberOfIslandsParameter.Value = value; }
+    }
+    public IntValue MigrationInterval {
+      get { return MigrationIntervalParameter.Value; }
+      set { MigrationIntervalParameter.Value = value; }
+    }
+    public PercentValue MigrationRate {
+      get { return MigrationRateParameter.Value; }
+      set { MigrationRateParameter.Value = value; }
+    }
+    public IMigrator Migrator {
+      get { return MigratorParameter.Value; }
+      set { MigratorParameter.Value = value; }
+    }
+    public ISelector EmigrantsSelector {
+      get { return EmigrantsSelectorParameter.Value; }
+      set { EmigrantsSelectorParameter.Value = value; }
+    }
+    public ISelector ImmigrationSelector {
+      get { return ImmigrationSelectorParameter.Value; }
+      set { ImmigrationSelectorParameter.Value = value; }
+    }
+    public IntValue PopulationSize {
+      get { return PopulationSizeParameter.Value; }
+      set { PopulationSizeParameter.Value = value; }
+    }
+    public IntValue MaximumMigrations {
+      get { return MaximumMigrationsParameter.Value; }
+      set { MaximumMigrationsParameter.Value = value; }
+    }
+    public ISelector Selector {
+      get { return SelectorParameter.Value; }
+      set { SelectorParameter.Value = value; }
+    }
+    public ICrossover Crossover {
+      get { return CrossoverParameter.Value; }
+      set { CrossoverParameter.Value = value; }
+    }
+    public PercentValue MutationProbability {
+      get { return MutationProbabilityParameter.Value; }
+      set { MutationProbabilityParameter.Value = value; }
+    }
+    public IManipulator Mutator {
+      get { return MutatorParameter.Value; }
+      set { MutatorParameter.Value = value; }
+    }
+    public IntValue Elites {
+      get { return ElitesParameter.Value; }
+      set { ElitesParameter.Value = value; }
+    }
+    public BoolValue Parallel {
+      get { return ParallelParameter.Value; }
+      set { ParallelParameter.Value = value; }
+    }
+    private List<ISelector> selectors;
+    private IEnumerable<ISelector> Selectors {
+      get { return selectors; }
+    }
+    private List<ISelector> emigrantsSelectors;
+    private List<ISelector> immigrationSelectors;
+    private List<IMigrator> migrators;
+    #endregion
+
+    [StorableConstructor]
+    private IslandGeneticAlgorithm(bool deserializing) : base(deserializing) { }
+    public IslandGeneticAlgorithm()
+      : base() {
+      Parameters.Add(new ValueParameter<IntValue>("Seed", "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
+      Parameters.Add(new ValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfIslands", "The number of islands.", new IntValue(5)));
+      Parameters.Add(new ValueParameter<IntValue>("MigrationInterval", "The number of generations that should pass between migration phases.", new IntValue(20)));
+      Parameters.Add(new ValueParameter<PercentValue>("MigrationRate", "The proportion of individuals that should migrate between the islands.", new PercentValue(0.15)));
+      Parameters.Add(new ConstrainedValueParameter<IMigrator>("Migrator", "The migration strategy."));
+      Parameters.Add(new ConstrainedValueParameter<ISelector>("EmigrantsSelector", "Selects the individuals that will be migrated."));
+      Parameters.Add(new ConstrainedValueParameter<ISelector>("ImmigrationSelector", "Selects the population from the unification of the original population and the immigrants."));
+      Parameters.Add(new ValueParameter<IntValue>("PopulationSize", "The size of the population of solutions.", new IntValue(100)));
+      Parameters.Add(new ValueParameter<IntValue>("MaximumMigrations", "The maximum number of migrations that should occur.", new IntValue(100)));
+      Parameters.Add(new ConstrainedValueParameter<ISelector>("Selector", "The operator used to select solutions for reproduction."));
+      Parameters.Add(new ConstrainedValueParameter<ICrossover>("Crossover", "The operator used to cross solutions."));
+      Parameters.Add(new ValueParameter<PercentValue>("MutationProbability", "The probability that the mutation operator is applied on a solution.", new PercentValue(0.05)));
+      Parameters.Add(new OptionalConstrainedValueParameter<IManipulator>("Mutator", "The operator used to mutate solutions."));
+      Parameters.Add(new ValueParameter<IntValue>("Elites", "The numer of elite solutions which are kept in each generation.", new IntValue(1)));
+      Parameters.Add(new ValueParameter<BoolValue>("Parallel", "True if the islands should be run in parallel (also requires a parallel engine)", new BoolValue(false)));
+
+      randomCreator = new RandomCreator();
+      SubScopesCreator populationCreator = new SubScopesCreator();
+      UniformSubScopesProcessor ussp1 = new UniformSubScopesProcessor();
+      solutionsCreator = new SolutionsCreator();
+      mainLoop = new IslandGeneticAlgorithmMainLoop();
+      OperatorGraph.InitialOperator = randomCreator;
+
+      randomCreator.RandomParameter.ActualName = "Random";
+      randomCreator.SeedParameter.ActualName = SeedParameter.Name;
+      randomCreator.SeedParameter.Value = null;
+      randomCreator.SetSeedRandomlyParameter.ActualName = SetSeedRandomlyParameter.Name;
+      randomCreator.SetSeedRandomlyParameter.Value = null;
+      randomCreator.Successor = populationCreator;
+
+      populationCreator.NumberOfSubScopesParameter.ActualName = NumberOfIslandsParameter.Name;
+      populationCreator.Successor = ussp1;
+
+      ussp1.Operator = solutionsCreator;
+      ussp1.Successor = mainLoop;
+
+      solutionsCreator.NumberOfSolutionsParameter.ActualName = PopulationSizeParameter.Name;
+      solutionsCreator.Successor = null;
+
+      mainLoop.EmigrantsSelectorParameter.ActualName = EmigrantsSelectorParameter.Name;
+      mainLoop.ImmigrationSelectorParameter.ActualName = ImmigrationSelectorParameter.Name;
+      mainLoop.MaximumMigrationsParameter.ActualName = MaximumMigrationsParameter.Name;
+      mainLoop.MigrationIntervalParameter.ActualName = MigrationIntervalParameter.Name;
+      mainLoop.MigrationRateParameter.ActualName = MigrationRateParameter.Name;
+      mainLoop.MigratorParameter.ActualName = MigratorParameter.Name;
+      mainLoop.NumberOfIslandsParameter.ActualName = NumberOfIslandsParameter.Name;
+      mainLoop.SelectorParameter.ActualName = SelectorParameter.Name;
+      mainLoop.CrossoverParameter.ActualName = CrossoverParameter.Name;
+      mainLoop.ElitesParameter.ActualName = ElitesParameter.Name;
+      mainLoop.MutatorParameter.ActualName = MutatorParameter.Name;
+      mainLoop.MutationProbabilityParameter.ActualName = MutationProbabilityParameter.Name;
+      mainLoop.RandomParameter.ActualName = randomCreator.RandomParameter.ActualName;
+      mainLoop.ResultsParameter.ActualName = "Results";
+
+      mainLoop.Successor = null;
+
+      Initialize();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      IslandGeneticAlgorithm clone = (IslandGeneticAlgorithm)base.Clone(cloner);
+      clone.Initialize();
+      return clone;
+    }
+
+    public override void Prepare() {
+      if (Problem != null) base.Prepare();
+    }
+
+    #region Events
+    protected override void OnProblemChanged() {
+      ParameterizeStochasticOperator(Problem.SolutionCreator);
+      ParameterizeStochasticOperator(Problem.Evaluator);
+      ParameterizeStochasticOperator(Problem.Visualizer);
+      foreach (IOperator op in Problem.Operators) ParameterizeStochasticOperator(op);
+      ParameterizeSolutionsCreator();
+      ParameterizeMainLoop();
+      ParameterizeSelectors();
+      UpdateCrossovers();
+      UpdateMutators();
+      Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+      if (Problem.Visualizer != null) Problem.Visualizer.VisualizationParameter.ActualNameChanged += new EventHandler(Visualizer_VisualizationParameter_ActualNameChanged);
+      base.OnProblemChanged();
+    }
+
+    protected override void Problem_SolutionCreatorChanged(object sender, EventArgs e) {
+      ParameterizeStochasticOperator(Problem.SolutionCreator);
+      ParameterizeSolutionsCreator();
+      base.Problem_SolutionCreatorChanged(sender, e);
+    }
+    protected override void Problem_EvaluatorChanged(object sender, EventArgs e) {
+      ParameterizeStochasticOperator(Problem.Evaluator);
+      ParameterizeSolutionsCreator();
+      ParameterizeMainLoop();
+      ParameterizeSelectors();
+      Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+      base.Problem_EvaluatorChanged(sender, e);
+    }
+    protected override void Problem_VisualizerChanged(object sender, EventArgs e) {
+      ParameterizeStochasticOperator(Problem.Visualizer);
+      ParameterizeMainLoop();
+      if (Problem.Visualizer != null) Problem.Visualizer.VisualizationParameter.ActualNameChanged += new EventHandler(Visualizer_VisualizationParameter_ActualNameChanged);
+      base.Problem_VisualizerChanged(sender, e);
+    }
+    protected override void Problem_OperatorsChanged(object sender, EventArgs e) {
+      foreach (IOperator op in Problem.Operators) ParameterizeStochasticOperator(op);
+      UpdateCrossovers();
+      UpdateMutators();
+      base.Problem_OperatorsChanged(sender, e);
+    }
+    private void ElitesParameter_ValueChanged(object sender, EventArgs e) {
+      Elites.ValueChanged += new EventHandler(Elites_ValueChanged);
+      ParameterizeSelectors();
+    }
+    private void Elites_ValueChanged(object sender, EventArgs e) {
+      ParameterizeSelectors();
+    }
+    private void PopulationSizeParameter_ValueChanged(object sender, EventArgs e) {
+      NumberOfIslands.ValueChanged += new EventHandler(PopulationSize_ValueChanged);
+      ParameterizeSelectors();
+    }
+    private void PopulationSize_ValueChanged(object sender, EventArgs e) {
+      ParameterizeSelectors();
+    }
+    private void Evaluator_QualityParameter_ActualNameChanged(object sender, EventArgs e) {
+      ParameterizeMainLoop();
+      ParameterizeSelectors();
+    }
+    private void Visualizer_VisualizationParameter_ActualNameChanged(object sender, EventArgs e) {
+      ParameterizeMainLoop();
+    }
+    private void MigrationRateParameter_ValueChanged(object sender, EventArgs e) {
+      MigrationRate.ValueChanged += new EventHandler(MigrationRate_ValueChanged);
+      ParameterizeSelectors();
+    }
+    private void MigrationRate_ValueChanged(object sender, EventArgs e) {
+      ParameterizeSelectors();
+    }
+    #endregion
+
+    #region Helpers
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      InitializeSelectors();
+      UpdateSelectors();
+      InitializeMigrators();
+      UpdateMigrators();
+      PopulationSizeParameter.ValueChanged += new EventHandler(PopulationSizeParameter_ValueChanged);
+      PopulationSize.ValueChanged += new EventHandler(PopulationSize_ValueChanged);
+      MigrationRateParameter.ValueChanged += new EventHandler(MigrationRateParameter_ValueChanged);
+      MigrationRate.ValueChanged += new EventHandler(MigrationRate_ValueChanged);
+      ElitesParameter.ValueChanged += new EventHandler(ElitesParameter_ValueChanged);
+      Elites.ValueChanged += new EventHandler(Elites_ValueChanged);
+      if (Problem != null) {
+        UpdateCrossovers();
+        UpdateMutators();
+        Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+        if (Problem.Visualizer != null) Problem.Visualizer.VisualizationParameter.ActualNameChanged += new EventHandler(Visualizer_VisualizationParameter_ActualNameChanged);
+      }
+    }
+    private void ParameterizeSolutionsCreator() {
+      solutionsCreator.EvaluatorParameter.ActualName = Problem.EvaluatorParameter.Name;
+      solutionsCreator.SolutionCreatorParameter.ActualName = Problem.SolutionCreatorParameter.Name;
+    }
+    private void ParameterizeMainLoop() {
+      mainLoop.BestKnownQualityParameter.ActualName = Problem.BestKnownQualityParameter.Name;
+      mainLoop.EvaluatorParameter.ActualName = Problem.EvaluatorParameter.Name;
+      mainLoop.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
+      mainLoop.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+      mainLoop.VisualizerParameter.ActualName = Problem.VisualizerParameter.Name;
+      if (Problem.Visualizer != null)
+        mainLoop.VisualizationParameter.ActualName = Problem.Visualizer.VisualizationParameter.ActualName;
+    }
+    private void ParameterizeStochasticOperator(IOperator op) {
+      if (op is IStochasticOperator)
+        ((IStochasticOperator)op).RandomParameter.ActualName = randomCreator.RandomParameter.ActualName;
+    }
+    private void InitializeSelectors() {
+      selectors = new List<ISelector>();
+      selectors.AddRange(ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name));
+      emigrantsSelectors = new List<ISelector>();
+      emigrantsSelectors.AddRange(ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name));
+      immigrationSelectors = new List<ISelector>();
+      immigrationSelectors.AddRange(ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name));
+      ParameterizeSelectors();
+    }
+    private void InitializeMigrators() {
+      migrators = new List<IMigrator>();
+      migrators.AddRange(ApplicationManager.Manager.GetInstances<IMigrator>().OrderBy(x => x.Name));
+      UpdateMigrators();
+    }
+    private void ParameterizeSelectors() {
+      foreach (ISelector selector in Selectors) {
+        selector.CopySelected = new BoolValue(true);
+        selector.NumberOfSelectedSubScopesParameter.Value = new IntValue(2 * (PopulationSize.Value - Elites.Value));
+        ParameterizeStochasticOperator(selector);
+      }
+      foreach (ISelector selector in emigrantsSelectors) {
+        selector.CopySelected = new BoolValue(true);
+        selector.NumberOfSelectedSubScopesParameter.Value = new IntValue((int)Math.Ceiling(PopulationSize.Value * MigrationRate.Value));
+        ParameterizeStochasticOperator(selector);
+      }
+      foreach (ISelector selector in immigrationSelectors) {
+        selector.CopySelected = new BoolValue(false);
+        selector.NumberOfSelectedSubScopesParameter.Value = PopulationSize;
+        ParameterizeStochasticOperator(selector);
+      }
+      if (Problem != null) {
+        foreach (ISingleObjectiveSelector selector in Selectors.OfType<ISingleObjectiveSelector>()) {
+          selector.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
+          selector.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+        }
+        foreach (ISingleObjectiveSelector selector in emigrantsSelectors.OfType<ISingleObjectiveSelector>()) {
+          selector.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
+          selector.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+        }
+        foreach (ISingleObjectiveSelector selector in immigrationSelectors.OfType<ISingleObjectiveSelector>()) {
+          selector.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
+          selector.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+        }
+      }
+    }
+    private void UpdateSelectors() {
+      ISelector oldSelector = SelectorParameter.Value;
+      SelectorParameter.ValidValues.Clear();
+      foreach (ISelector selector in Selectors.OrderBy(x => x.Name))
+        SelectorParameter.ValidValues.Add(selector);
+
+      ISelector proportionalSelector = SelectorParameter.ValidValues.FirstOrDefault(x => x.GetType().Name.Equals("ProportionalSelector"));
+      if (proportionalSelector != null) SelectorParameter.Value = proportionalSelector;
+
+      if (oldSelector != null) {
+        ISelector selector = SelectorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldSelector.GetType());
+        if (selector != null) SelectorParameter.Value = selector;
+      }
+
+      oldSelector = EmigrantsSelector;
+      EmigrantsSelectorParameter.ValidValues.Clear();
+      foreach (ISelector selector in emigrantsSelectors)
+        EmigrantsSelectorParameter.ValidValues.Add(selector);
+      if (oldSelector != null) {
+        ISelector selector = EmigrantsSelectorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldSelector.GetType());
+        if (selector != null) EmigrantsSelectorParameter.Value = selector;
+      }
+
+      oldSelector = ImmigrationSelectorParameter.Value;
+      ImmigrationSelectorParameter.ValidValues.Clear();
+      foreach (ISelector selector in immigrationSelectors)
+        ImmigrationSelectorParameter.ValidValues.Add(selector);
+      if (oldSelector != null) {
+        ISelector selector = ImmigrationSelectorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldSelector.GetType());
+        if (selector != null) ImmigrationSelectorParameter.Value = selector;
+      }
+    }
+    private void UpdateMigrators() {
+      IMigrator oldMigrator = Migrator;
+      MigratorParameter.ValidValues.Clear();
+      foreach (IMigrator migrator in migrators)
+        MigratorParameter.ValidValues.Add(migrator);
+      if (oldMigrator != null) {
+        IMigrator migrator = MigratorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMigrator.GetType());
+        if (migrator != null) MigratorParameter.Value = migrator;
+      } else if (MigratorParameter.ValidValues.Count > 0) MigratorParameter.Value = MigratorParameter.ValidValues.First();
+    }
+    private void UpdateCrossovers() {
+      ICrossover oldCrossover = CrossoverParameter.Value;
+      CrossoverParameter.ValidValues.Clear();
+      foreach (ICrossover crossover in Problem.Operators.OfType<ICrossover>().OrderBy(x => x.Name))
+        CrossoverParameter.ValidValues.Add(crossover);
+      if (oldCrossover != null) {
+        ICrossover crossover = CrossoverParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldCrossover.GetType());
+        if (crossover != null) CrossoverParameter.Value = crossover;
+      }
+    }
+    private void UpdateMutators() {
+      IManipulator oldMutator = MutatorParameter.Value;
+      MutatorParameter.ValidValues.Clear();
+      foreach (IManipulator mutator in Problem.Operators.OfType<IManipulator>().OrderBy(x => x.Name))
+        MutatorParameter.ValidValues.Add(mutator);
+      if (oldMutator != null) {
+        IManipulator mutator = MutatorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMutator.GetType());
+        if (mutator != null) MutatorParameter.Value = mutator;
+      }
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs	(revision 3356)
+++ /trunk/sources/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs	(revision 3356)
@@ -0,0 +1,311 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Selection;
+
+namespace HeuristicLab.Algorithms.GeneticAlgorithm {
+  /// <summary>
+  /// An island genetic algorithm main loop operator.
+  /// </summary>
+  [Item("IslandGeneticAlgorithmMainLoop", "An island genetic algorithm main loop operator.")]
+  [StorableClass]
+  public sealed class IslandGeneticAlgorithmMainLoop : AlgorithmOperator {
+    #region Parameter Properties
+    public ValueLookupParameter<IRandom> RandomParameter {
+      get { return (ValueLookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ValueLookupParameter<BoolValue> MaximizationParameter {
+      get { return (ValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    public SubScopesLookupParameter<DoubleValue> QualityParameter {
+      get { return (SubScopesLookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ValueLookupParameter<DoubleValue> BestKnownQualityParameter {
+      get { return (ValueLookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
+    }
+    public ValueLookupParameter<IntValue> NumberOfIslandsParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["NumberOfIslands"]; }
+    }
+    public ValueLookupParameter<IntValue> MigrationIntervalParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["MigrationInterval"]; }
+    }
+    public ValueLookupParameter<PercentValue> MigrationRateParameter {
+      get { return (ValueLookupParameter<PercentValue>)Parameters["MigrationRate"]; }
+    }
+    public ValueLookupParameter<IOperator> MigratorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Migrator"]; }
+    }
+    public ValueLookupParameter<IOperator> EmigrantsSelectorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["EmigrantsSelector"]; }
+    }
+    public ValueLookupParameter<IOperator> ImmigrationSelectorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["ImmigrationSelector"]; }
+    }
+    public ValueLookupParameter<IntValue> PopulationSizeParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["PopulationSize"]; }
+    }
+    public ValueLookupParameter<IntValue> MaximumMigrationsParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["MaximumMigrations"]; }
+    }
+    public ValueLookupParameter<IOperator> SelectorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Selector"]; }
+    }
+    public ValueLookupParameter<IOperator> CrossoverParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Crossover"]; }
+    }
+    public ValueLookupParameter<PercentValue> MutationProbabilityParameter {
+      get { return (ValueLookupParameter<PercentValue>)Parameters["MutationProbability"]; }
+    }
+    public ValueLookupParameter<IOperator> MutatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Mutator"]; }
+    }
+    public ValueLookupParameter<IOperator> EvaluatorParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Evaluator"]; }
+    }
+    public ValueLookupParameter<IntValue> ElitesParameter {
+      get { return (ValueLookupParameter<IntValue>)Parameters["Elites"]; }
+    }
+    public ValueLookupParameter<ResultCollection> ResultsParameter {
+      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    public ValueLookupParameter<IOperator> VisualizerParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["Visualizer"]; }
+    }
+    public LookupParameter<IItem> VisualizationParameter {
+      get { return (LookupParameter<IItem>)Parameters["Visualization"]; }
+    }
+    #endregion
+
+    /*#region Properties
+    private GeneticAlgorithmMainLoop GeneticAlgorithmMainLoop {
+      get { return (GeneticAlgorithmMainLoop)((UniformSubScopesProcessor)OperatorGraph.InitialOperator).Operator; }
+    }
+    #endregion*/
+
+    [StorableConstructor]
+    private IslandGeneticAlgorithmMainLoop(bool deserializing) : base() { }
+    public IslandGeneticAlgorithmMainLoop()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new ValueLookupParameter<IRandom>("Random", "A pseudo random number generator."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
+      Parameters.Add(new SubScopesLookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("BestKnownQuality", "The best known quality value found so far."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfIslands", "The number of islands."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MigrationInterval", "The number of generations that should pass between migration phases."));
+      Parameters.Add(new ValueLookupParameter<PercentValue>("MigrationRate", "The proportion of individuals that should migrate between the islands."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Migrator", "The migration strategy."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("EmigrantsSelector", "Selects the individuals that will be migrated."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("ImmigrationSelector", "Selects the population from the unification of the original population and the immigrants."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("PopulationSize", "The size of the population of solutions."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumMigrations", "The maximum number of migrations after which the operator should terminate."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Selector", "The operator used to select solutions for reproduction."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Crossover", "The operator used to cross solutions."));
+      Parameters.Add(new ValueLookupParameter<PercentValue>("MutationProbability", "The probability that the mutation operator is applied on a solution."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Mutator", "The operator used to mutate solutions."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator", "The operator used to evaluate solutions."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Elites", "The numer of elite solutions which are kept in each generation."));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection to store the results."));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Visualizer", "The operator used to visualize solutions."));
+      Parameters.Add(new LookupParameter<IItem>("Visualization", "The item which represents the visualization of solutions."));
+      #endregion
+
+      #region Create operators
+      VariableCreator variableCreator = new VariableCreator();
+      UniformSubScopesProcessor ussp0 = new UniformSubScopesProcessor();
+      VariableCreator resultCollectionCreator = new VariableCreator();
+      BestQualityMemorizer bestQualityMemorizer1 = new BestQualityMemorizer();
+      BestAverageWorstQualityCalculator bestAverageWorstQualityCalculator1 = new BestAverageWorstQualityCalculator();
+      BestQualityMemorizer bestQualityMemorizer2 = new BestQualityMemorizer();
+      BestAverageWorstQualityCalculator bestAverageWorstQualityCalculator2 = new BestAverageWorstQualityCalculator();
+      DataTableValuesCollector dataTableValuesCollector1 = new DataTableValuesCollector();
+      QualityDifferenceCalculator qualityDifferenceCalculator1 = new QualityDifferenceCalculator();
+      ResultsCollector resultsCollector = new ResultsCollector();
+      UniformSubScopesProcessor ussp1 = new UniformSubScopesProcessor();
+      GeneticAlgorithmMainLoop geneticAlgorithmMainLoop = new GeneticAlgorithmMainLoop();
+      Placeholder emigrantsSelector = new Placeholder();
+      Placeholder migrator = new Placeholder();
+      UniformSubScopesProcessor ussp2 = new UniformSubScopesProcessor();
+      MergingReducer mergingReducer = new MergingReducer();
+      Placeholder immigrationSelector = new Placeholder();
+      RightReducer rightReducer = new RightReducer();
+      IntCounter migrationsCounter = new IntCounter();
+      Comparator maxMigrationsComparator = new Comparator();
+      BestQualityMemorizer bestQualityMemorizer3 = new BestQualityMemorizer();
+      BestAverageWorstQualityCalculator bestAverageWorstQualityCalculator3 = new BestAverageWorstQualityCalculator();
+      DataTableValuesCollector dataTableValuesCollector2 = new DataTableValuesCollector();
+      QualityDifferenceCalculator qualityDifferenceCalculator2 = new QualityDifferenceCalculator();
+      ConditionalBranch migrationTerminationCondition = new ConditionalBranch();
+
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Migrations", new IntValue(0)));
+
+      resultCollectionCreator.CollectedValues.Add(new ValueParameter<ResultCollection>("IslandResults", new ResultCollection()));
+
+      bestQualityMemorizer1.BestQualityParameter.ActualName = "BestQuality";
+      bestQualityMemorizer1.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestQualityMemorizer1.QualityParameter.ActualName = QualityParameter.Name;
+
+      bestAverageWorstQualityCalculator1.AverageQualityParameter.ActualName = "CurrentAverageQuality";
+      bestAverageWorstQualityCalculator1.BestQualityParameter.ActualName = "CurrentBestQuality";
+      bestAverageWorstQualityCalculator1.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestAverageWorstQualityCalculator1.QualityParameter.ActualName = QualityParameter.Name;
+      bestAverageWorstQualityCalculator1.WorstQualityParameter.ActualName = "CurrentWorstQuality";
+
+      bestQualityMemorizer2.BestQualityParameter.ActualName = "BestQuality";
+      bestQualityMemorizer2.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestQualityMemorizer2.QualityParameter.ActualName = "BestQuality";
+
+      bestAverageWorstQualityCalculator2.AverageQualityParameter.ActualName = "CurrentAverageBestQuality";
+      bestAverageWorstQualityCalculator2.BestQualityParameter.ActualName = "CurrentBestBestQuality";
+      bestAverageWorstQualityCalculator2.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestAverageWorstQualityCalculator2.QualityParameter.ActualName = "CurrentBestQuality";
+      bestAverageWorstQualityCalculator2.WorstQualityParameter.ActualName = "CurrentWorstBestQuality";
+
+      dataTableValuesCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Best BestQuality", null, "CurrentBestBestQuality"));
+      dataTableValuesCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Average BestQuality", null, "CurrentAverageBestQuality"));
+      dataTableValuesCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Worst BestQuality", null, "CurrentWorstBestQuality"));
+      dataTableValuesCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Quality", null, "BestQuality"));
+      dataTableValuesCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Known Quality", null, BestKnownQualityParameter.Name));
+      dataTableValuesCollector1.DataTableParameter.ActualName = "BestQualities";
+
+      qualityDifferenceCalculator1.AbsoluteDifferenceParameter.ActualName = "AbsoluteDifferenceBestKnownToBest";
+      qualityDifferenceCalculator1.FirstQualityParameter.ActualName = BestKnownQualityParameter.Name;
+      qualityDifferenceCalculator1.RelativeDifferenceParameter.ActualName = "RelativeDifferenceBestKnownToBest";
+      qualityDifferenceCalculator1.SecondQualityParameter.ActualName = "BestQuality";
+
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("Migrations"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Best BestQuality", null, "CurrentBestBestQuality"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Average BestQuality", null, "CurrentAverageBestQuality"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Worst BestQuality", null, "CurrentWorstBestQuality"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Quality", null, "BestQuality"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Known Quality", null, BestKnownQualityParameter.Name));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Absolute Difference of Best Known Quality to Best Quality", null, "AbsoluteDifferenceBestKnownToBest"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DoubleValue>("Relative Difference of Best Known Quality to Best Quality", null, "RelativeDifferenceBestKnownToBest"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DataTable>("BestQualities"));
+      resultsCollector.CollectedValues.Add(new SubScopesLookupParameter<ResultCollection>("IslandResults", "Result set for each island"));
+      resultsCollector.ResultsParameter.ActualName = ResultsParameter.Name;
+
+      geneticAlgorithmMainLoop.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
+      geneticAlgorithmMainLoop.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      geneticAlgorithmMainLoop.QualityParameter.ActualName = QualityParameter.Name;
+      geneticAlgorithmMainLoop.SelectorParameter.ActualName = SelectorParameter.Name;
+      geneticAlgorithmMainLoop.CrossoverParameter.ActualName = CrossoverParameter.Name;
+      geneticAlgorithmMainLoop.ElitesParameter.ActualName = ElitesParameter.Name;
+      geneticAlgorithmMainLoop.MaximumGenerationsParameter.ActualName = MigrationIntervalParameter.Name;
+      geneticAlgorithmMainLoop.MutatorParameter.ActualName = MutatorParameter.Name;
+      geneticAlgorithmMainLoop.EvaluatorParameter.ActualName = EvaluatorParameter.Name;
+      geneticAlgorithmMainLoop.MutationProbabilityParameter.ActualName = MutationProbabilityParameter.Name;
+      geneticAlgorithmMainLoop.RandomParameter.ActualName = RandomParameter.Name;
+      geneticAlgorithmMainLoop.ResultsParameter.ActualName = "IslandResults";
+      geneticAlgorithmMainLoop.VisualizerParameter.ActualName = VisualizerParameter.Name;
+      geneticAlgorithmMainLoop.VisualizationParameter.ActualName = VisualizationParameter.Name;
+
+      emigrantsSelector.Name = "Emigrants Selector (placeholder)";
+      emigrantsSelector.OperatorParameter.ActualName = EmigrantsSelectorParameter.Name;
+
+      migrator.Name = "Migrator (placeholder)";
+      migrator.OperatorParameter.ActualName = MigratorParameter.Name;
+
+      immigrationSelector.Name = "Immigration Selector (placeholder)";
+      immigrationSelector.OperatorParameter.ActualName = ImmigrationSelectorParameter.Name;
+
+      migrationsCounter.Name = "Migrations + 1";
+      migrationsCounter.IncrementParameter.Value = new IntValue(1);
+      migrationsCounter.ValueParameter.ActualName = "Migrations";
+
+      maxMigrationsComparator.Name = "Migrations >= MaximumMigration ?";
+      maxMigrationsComparator.LeftSideParameter.ActualName = "Migrations";
+      maxMigrationsComparator.RightSideParameter.ActualName = MaximumMigrationsParameter.Name;
+      maxMigrationsComparator.Comparison.Value = ComparisonType.GreaterOrEqual;
+      maxMigrationsComparator.ResultParameter.ActualName = "MigrationTerminate";
+
+      bestQualityMemorizer3.BestQualityParameter.ActualName = "BestQuality";
+      bestQualityMemorizer3.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestQualityMemorizer3.QualityParameter.ActualName = "BestQuality";
+
+      bestAverageWorstQualityCalculator3.AverageQualityParameter.ActualName = "CurrentAverageBestQuality";
+      bestAverageWorstQualityCalculator3.BestQualityParameter.ActualName = "CurrentBestBestQuality";
+      bestAverageWorstQualityCalculator3.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestAverageWorstQualityCalculator3.QualityParameter.ActualName = "CurrentBestQuality";
+      bestAverageWorstQualityCalculator3.WorstQualityParameter.ActualName = "CurrentWorstBestQuality";
+
+      dataTableValuesCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Best BestQuality", null, "CurrentBestBestQuality"));
+      dataTableValuesCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Average BestQuality", null, "CurrentAverageBestQuality"));
+      dataTableValuesCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>("Current Worst BestQuality", null, "CurrentWorstBestQuality"));
+      dataTableValuesCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Quality", null, "BestQuality"));
+      dataTableValuesCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Known Quality", null, BestKnownQualityParameter.Name));
+      dataTableValuesCollector2.DataTableParameter.ActualName = "BestQualities";
+
+      qualityDifferenceCalculator2.AbsoluteDifferenceParameter.ActualName = "AbsoluteDifferenceBestKnownToBest";
+      qualityDifferenceCalculator2.FirstQualityParameter.ActualName = BestKnownQualityParameter.Name;
+      qualityDifferenceCalculator2.RelativeDifferenceParameter.ActualName = "RelativeDifferenceBestKnownToBest";
+      qualityDifferenceCalculator2.SecondQualityParameter.ActualName = "BestQuality";
+
+      migrationTerminationCondition.ConditionParameter.ActualName = "MigrationTerminate";
+      #endregion
+
+      #region Create operator graph
+      OperatorGraph.InitialOperator = variableCreator;
+      variableCreator.Successor = ussp0;
+      ussp0.Operator = resultCollectionCreator;
+      ussp0.Successor = bestQualityMemorizer2;
+      resultCollectionCreator.Successor = bestQualityMemorizer1;
+      bestQualityMemorizer1.Successor = bestAverageWorstQualityCalculator1;
+      bestQualityMemorizer2.Successor = bestAverageWorstQualityCalculator2;
+      bestAverageWorstQualityCalculator2.Successor = dataTableValuesCollector1;
+      dataTableValuesCollector1.Successor = qualityDifferenceCalculator1;
+      qualityDifferenceCalculator1.Successor = resultsCollector;
+      resultsCollector.Successor = ussp1;
+      ussp1.Operator = geneticAlgorithmMainLoop;
+      ussp1.Successor = migrator;
+      geneticAlgorithmMainLoop.Successor = emigrantsSelector;
+      emigrantsSelector.Successor = null;
+      migrator.Successor = ussp2;
+      ussp2.Operator = mergingReducer;
+      ussp2.Successor = migrationsCounter;
+      mergingReducer.Successor = immigrationSelector;
+      immigrationSelector.Successor = rightReducer;
+      rightReducer.Successor = null;
+      migrationsCounter.Successor = maxMigrationsComparator;
+      maxMigrationsComparator.Successor = bestQualityMemorizer3;
+      bestQualityMemorizer3.Successor = bestAverageWorstQualityCalculator3;
+      bestAverageWorstQualityCalculator3.Successor = dataTableValuesCollector2;
+      dataTableValuesCollector2.Successor = qualityDifferenceCalculator2;
+      qualityDifferenceCalculator2.Successor = migrationTerminationCondition;
+      migrationTerminationCondition.FalseBranch = ussp1;
+      migrationTerminationCondition.TrueBranch = null;
+      migrationTerminationCondition.Successor = null;
+      #endregion
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.MultipopulationAlgorithm/3.3/HeuristicLab.Algorithms.MultipopulationAlgorithm-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.MultipopulationAlgorithm/3.3/HeuristicLab.Algorithms.MultipopulationAlgorithm-3.3.csproj	(revision 3355)
+++ /trunk/sources/HeuristicLab.Algorithms.MultipopulationAlgorithm/3.3/HeuristicLab.Algorithms.MultipopulationAlgorithm-3.3.csproj	(revision 3356)
@@ -82,4 +82,5 @@
     <None Include="HeuristicLabAlgorithmsMultipopulationAlgorithmPlugin.cs.frame" />
     <Compile Include="HeuristicLabAlgorithmsMultipopulationAlgorithmPlugin.cs" />
+    <Compile Include="MultipopulationAlgorithm.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <None Include="Properties\AssemblyInfo.frame" />
@@ -89,7 +90,43 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
+      <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
+      <Name>HeuristicLab.Operators-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization.Operators\3.3\HeuristicLab.Optimization.Operators-3.3.csproj">
+      <Project>{25087811-F74C-4128-BC86-8324271DA13E}</Project>
+      <Name>HeuristicLab.Optimization.Operators-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
       <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj">
+      <Project>{F4539FB6-4708-40C9-BE64-0A1390AEA197}</Project>
+      <Name>HeuristicLab.Random-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 3355)
+++ /trunk/sources/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 3356)
@@ -93,4 +93,5 @@
     <Compile Include="QualityComparator.cs" />
     <Compile Include="SolutionsCreator.cs" />
+    <Compile Include="UnidirectionalRingMigrator.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs	(revision 3355)
+++ /trunk/sources/HeuristicLab.Optimization.Operators/3.3/UnidirectionalRingMigrator.cs	(revision 3356)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -20,38 +20,36 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Evolutionary {
+namespace HeuristicLab.Optimization.Operators {
   /// <summary>
-  /// Operator class that migrates one sub scope of each child to its left neighbour sub scope, like a ring.
+  /// Operator that migrates the selected sub scopes in each subscope in an unidirectional ring.
   /// </summary>
-  public class UnidirectionalRingMigrator : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  [Item("UnidirectionalRingMigrator", "Migrates the selected sub scopes in each subscope in an unidirectional ring.")]
+  [StorableClass]
+  public class UnidirectionalRingMigrator : SingleSuccessorOperator, IMigrator {
     /// <summary>
     /// Migrates every first sub scope of each child to its left neighbour (like a ring).
     /// <pre>                                                               
-    ///                    scope                    scope             
-    ///                /     |     \            /     |     \         
-    ///               A      B      C    =>    A      B      C           
-    ///              /|\    /|\    /|\        /|\    /|\    /|\       
-    ///             G H I  J K L  M N O      H I J  K L M  N O G     
+    ///          __ scope __              __ scope __
+    ///         /     |     \            /     |     \
+    ///       Pop1   Pop2   Pop3  =>   Pop1   Pop2   Pop3
+    ///       / \    / \    / \        / \    / \    / \
+    ///      R   S  R   S  R   S      R   S  R   S  R   S
+    ///     /|\  | /|\  | /|\  |     /|\  | /|\  | /|\  |
+    ///     ABC  A DEF  D GHI  G     ABC  G DEF  A GHI  D
     /// </pre>
     /// </summary>
-    /// <param name="scope">The scope whose sub scopes of the children should migrate.</param>
-    /// <returns><c>null</c>.</returns>
-    public override IOperation Apply(IScope scope) {
-      IList<IScope> emigrantsList = new List<IScope>();
+    /// <returns>The next operation.</returns>
+    public override IOperation Apply() {
+      IScope scope = ExecutionContext.Scope;
+      List<IScope> emigrantsList = new List<IScope>();
 
       for (int i = 0; i < scope.SubScopes.Count; i++) {
         IScope emigrants = scope.SubScopes[i].SubScopes[1];
-        scope.SubScopes[i].RemoveSubScope(emigrants);
+        scope.SubScopes[i].SubScopes.Remove(emigrants);
         emigrantsList.Add(emigrants);
       }
@@ -62,7 +60,7 @@
 
       for (int i = 0; i < scope.SubScopes.Count; i++)
-        scope.SubScopes[i].AddSubScope(emigrantsList[i]);
+        scope.SubScopes[i].SubScopes.Add(emigrantsList[i]);
 
-      return null;
+      return base.Apply();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 3355)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 3356)
@@ -87,4 +87,5 @@
     <Compile Include="Algorithm.cs" />
     <Compile Include="BatchRun.cs" />
+    <Compile Include="Interfaces\IMigrator.cs" />
     <Compile Include="Interfaces\ISelfAdaptiveManipulator.cs" />
     <Compile Include="Interfaces\IStrategyParameterCrossover.cs" />
Index: /trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs	(revision 3356)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs	(revision 3356)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization {
+  public interface IMigrator : IOperator { }
+}
